#Copyright 2008 Cold Spring Harbor Laboratory.
# Written by Yaniv Erlich (erlich@cshl.edu)

package State_machine_controller;

use strict;
use warnings;
use Readonly;
use Storable;
use File::Basename;
use Cwd 'abs_path';
use Carp;

require Exporter;

our @ISA    = ("Exporter");
our @EXPORT = qw(load save);

Readonly my $D_STATUS_FILENAME                          =>           'egg';
Readonly my $WATER_MARK_SIGN                            =>           '1';



sub save {

    my ($r_config) = @_;

    my $filename = $r_config->{'__r_config_filename__'} || abs_path ($D_STATUS_FILENAME);
    my $debug    = $r_config->{'debug'};
    my $stage    = $r_config->{'__stage__'};


    $r_config->{__r_config_filename__} = $filename;
    $r_config->{__watermark__}         = $WATER_MARK_SIGN;


    store $r_config, $filename;
    if (not -e $filename) {
        confess "Error in storing machine state. Can't find $filename: $!";
    }

    if ($debug) {
        print "Saving state machine. Currect state is:$stage\n";
    }

    return $filename;
}

sub load {
    my ($filename) = @_;

    if (not -e $filename) {
        confess "Can't find state machine file\n";
    }

    my $r_config = retrieve $filename;

    if ($r_config->{__watermark__} ne $WATER_MARK_SIGN) {
        confess "Probleming loading state machine. Is it from an old Alta-Cyclic version?";
    }

    if ($r_config->{debug}) {
        print "Loading state machine. Your current state is:",$r_config->{'__stage__'},"\n";
    }

    return $r_config;
}